<?php
/** Desinstalación, borrando las opciones empleadas.
 *
 * @package   WPblog AI Content Creator
 * @author    WPblog
 * @license   GPLv2
 * @link      https://wpblog.ir/
 */

// If uninstall.php is not called by WordPress, it dies.
defined( 'WP_UNINSTALL_PLUGIN' ) || die( esc_html( __( 'Access is not allowed.', 'wpblog-ai-content-creator' ) ) );

require_once plugin_dir_path( __FILE__ ) . 'lista-opciones.php';
require_once plugin_dir_path( __FILE__ ) . 'bbdd.php';

// Remove configuration options.
foreach ( aicc_lista_opciones() as $nombre_opcion ) {
	delete_option( $nombre_opcion );
	// Para los casos de multisite.
	delete_site_option( $nombre_opcion );
}

// Delete the tables created in the DB.
global $wpdb;

// Delete the table with the generations.
$tabla = aicc_tabla_generaciones();
// phpcs:ignore WordPress.DB.DirectDatabaseQuery.SchemaChange, WordPress.DB.DirectDatabaseQuery.DirectQuery, WordPress.DB.DirectDatabaseQuery.NoCaching
$wpdb->query( $wpdb->prepare( 'DROP TABLE IF EXISTS %s', $tabla ) );

// Delete the table with the Pixabay cache.
$tabla = aicc_tabla_pixabay_cache();
// phpcs:ignore WordPress.DB.DirectDatabaseQuery.SchemaChange, WordPress.DB.DirectDatabaseQuery.DirectQuery, WordPress.DB.DirectDatabaseQuery.NoCaching
$wpdb->query( $wpdb->prepare( 'DROP TABLE IF EXISTS %s', $tabla ) );
